#!/bin/sh
#
# This script will probably download the JRE from Netscape's server
# and install it.  This is a quick and dirty hack (much like Microsoft's
# famed operating system).  If it doesn't work, don't complain to me,
# at least I tried.  If it works, leap for joy and go shoot a chipmunk
# for me.  ;)
#
# No, there's no copyright - it's just a tiny script, not exactly
# something you'd want to patent.
#
# IF YOU USE A PROXY SERVER...
#
# If you're going through a proxy server then you'll need
# to uncomment the line below, entering the IP address
# of the proxy server in place of 'your.proxy.server', and
# also check that the HTTP proxy port on your proxy server
# is 8080, if not, change the number below as necessary.
# (FTP over HTTP uses the HTTP port).
#
#ftp_proxy="http://your.proxy.server:8080/"; export ftp_proxy

clear

# You may want to change this to the most up-to-date JRE.
# If you're not sure what the latest JRE is then search 
# the Netscape FTP site: ftp.netscape.com/pub
#
download_path="ftp://ftp.netscape.com/pub/netscape7/english/7.0_PR1/unix/linux22/xpi/jre.xpi"

declare -a line
echo -e '\E[32;40m' "Attempting to download JRE for Mozilla."; tput sgr0
echo
echo If you wish to abort at any time, press CTRL+C.
echo You can run this script again to resume the download.
echo
echo If your Internet connection is cut for any reason,
echo abort the script and run it again "(as defined above)".
echo 
echo Status of download is reported below:
echo
echo -e '\E[31;40m' "====================================================="; tput sgr0
echo

# wget downloads the file, and will continue downloading a
# partially downloaded file.
#
wget -c $download_path

echo -e '\E[31;40m' "====================================================="; tput sgr0
echo

# check if jre.xpi file exists
#
if [[ -e jre.xpi ]]
then
	echo File download complete.
	echo
else
	echo Download failed.
	echo
	exit 1
fi

echo Checking for Mozilla directory, please wait...
echo

# switch off echo
#
stty -echo

# check for Mozilla executable, export results to file
#
find /usr -name mozilla-bin -type f > found
echo end >> found

# switch echo back on
#
stty echo

fileList=found

lineCount=1

# parse file contents to array
#
until [ "${line[$lineCount-1]}" = "end" ]
do
	read line[$lineCount]
	let "lineCount+=1"
done <"$fileList"

# remove file
#
rm -f found

let "lineCount-=2"

# check for directory to install JRE
#
if [ $lineCount -gt 1 ]
then
	echo There appears to be more than one directory that
	echo the Mozilla executable file is installed in.
	echo
	echo Type the number of the directory that you wish to
	echo update, then press ENTER...
	echo 
	echo "(or type 'a' then ENTER to abort)"
	echo
	
	for ((j=1; j<=lineCount; j++))
	do
		echo $j : ${line[j]%mozilla-bin}
	done
	
	echo
	read selection
	
	if [ $selection = "a" ]
	then	
		echo Aborting.
		exit
	fi

	if [ $selection -lt 1 ] || [ $selection -gt $lineCount ]
	then
		echo "That option isn't available!"
		echo 
		echo Aborting.
		exit
	fi
	
	locate_file=${line[$selection]}
else
	locate_file=${line[1]}
	echo The directory containing the Mozilla executable file
	echo is ${locate_file%mozilla-bin}.
	echo
	echo To continue press ENTER...
	echo
	echo "(or type 'a' then ENTER to abort)"
	echo
	read selection

	if [ "$selection" = "a" ]
	then 
		exit
	fi
fi

dirname=${locate_file%mozilla-bin}

echo Installing...

# extract contents from jre.xpi and install
#
unzip -q jre.xpi -d $dirname/plugins 'jre-image-i386/*'
cd $dirname/plugins
ln -f -s jre-image-i386/plugin/i386/ns600/libjavaplugin_oji.so

echo
echo -e '\E[32;40m' "Installation complete."; tput sgr0
echo

exit
